import { LanguageClient } from 'javascript-typescript-langserver/lib/lang-handler';
import { InitializeParams } from 'javascript-typescript-langserver/lib/request-type';
import { TypeScriptService, TypeScriptServiceOptions } from 'javascript-typescript-langserver/lib/typescript-service';
import { Operation } from 'fast-json-patch';
import { Span } from 'opentracing';
import { Observable } from 'rxjs';
import { DocumentSymbolParams, Hover, Location, TextDocumentPositionParams } from 'vscode-languageserver';
import { FullParams } from '@elastic/lsp-extension';
export declare class ExtendedTypescriptService extends TypeScriptService {
    protected client: LanguageClient;
    protected options: TypeScriptServiceOptions;
    private dependencyManager;
    constructor(client: LanguageClient, options?: TypeScriptServiceOptions);
    protected _initializeFileSystems(accessDisk: boolean): void;
    initialize(params: InitializeParams, span?: Span): Observable<Operation>;
    shutdown(params?: {}, span?: Span): Observable<Operation>;
    private getHoverForSymbol;
    private emptyOperation;
    textDocumentFull(params: FullParams, span?: Span): Observable<Operation>;
    protected _getHover(params: TextDocumentPositionParams, span?: Span): Observable<Hover>;
    protected _getDefinitionLocations(params: TextDocumentPositionParams, span?: Span, goToType?: boolean): Observable<Location>;
    private convertLocation;
    private convertUri;
    private replaceWorkspaceInDoc;
    private replaceWorkspaceInString;
    private getPackageLocator;
    private getSymbolLocator;
    textDocumentEdefinition(params: TextDocumentPositionParams, span?: Span): Observable<Operation>;
    private getSymbolLocatorFromLocationInformation;
    private getQname;
    private getQnameBySymbolInformation;
    private getFileName;
    private cleanContainerName;
    textDocumentDocumentSymbol(params: DocumentSymbolParams, span?: Span): Observable<Operation>;
}
export declare type ExtendedTypescriptServiceFactory = (client: LanguageClient, options?: TypeScriptServiceOptions) => ExtendedTypescriptService;
